library macroscopic_tao_is_simplicity;
import 'dart:collection';
import 'package:flutter/widgets.dart';                                                                                                                                                                                                                                                                                                            abstract class IAppConfig {bool get isBeta;BuildContext get currentContext;ISpUtils get spUtils;ITipsInterceptor get tips;IRequestModel get requestModel;RefreshWidgetBuilder get refreshWidgetBuilder;IPagingListModel<T> pagingListModelBuilder<T>(IPagingListModel<T> childModel);IViewModel viewModelBuilder(IViewModel childModel);ILogPrint get logPrint;IBaseDao<T> getDao<T>(T t);}class AppComponent {static final IAppConfig _defAppConfig = _DefaultImpl();static IAppConfig? _appConfig;AppComponent._();static init({IAppConfig? appConfig}) {_appConfig = appConfig;}static IAppConfig get appConfig {return _appConfig ??= _defAppConfig;}}const IS_BETA = "@isBeta";const CURRENT_CONTEXT = "@currentContext";const SP_UTILS = "@spUtils";const TIPS = "@tips";const REQUEST_MODEL = "@requestModel";const REFRESH_WIDGET_BUILDER = "@refreshWidgetBuilder";const PAGING_LIST_MODEL_BUILDER = "@pagingListModelBuilder";const VIEW_MODEL_BUILDER = "@viewModelBuilder";const LOG_PRINT = "@logPrint";const DAO = "@DAO";class _DefaultImpl extends IAppConfig {@override bool get isBeta => FunctionRegistry.callMaybe(IS_BETA);@override BuildContext get currentContext =>FunctionRegistry.callMaybe(CURRENT_CONTEXT);@override IBaseDao<T> getDao<T>(T t) => FunctionRegistry.callMaybe(DAO, data: t);@override ILogPrint get logPrint => FunctionRegistry.callMaybe(LOG_PRINT);@override IPagingListModel<T> pagingListModelBuilder<T>(IPagingListModel<T> childModel) =>FunctionRegistry.callMaybe(PAGING_LIST_MODEL_BUILDER, data: childModel);@override RefreshWidgetBuilder get refreshWidgetBuilder =>FunctionRegistry.callMaybe(REFRESH_WIDGET_BUILDER);@override IRequestModel get requestModel => FunctionRegistry.callMaybe(REQUEST_MODEL);@override ISpUtils get spUtils => FunctionRegistry.callMaybe(SP_UTILS);@override ITipsInterceptor get tips => FunctionRegistry.callMaybe(TIPS);@override IViewModel viewModelBuilder(IViewModel childModel) =>FunctionRegistry.callMaybe(VIEW_MODEL_BUILDER);}abstract class IBaseDao<T> {Future<dynamic> insert<T>(List<T> tList, {bool transaction = false});Future<dynamic> delete(List<num> pkList, {bool transaction = false});Future<dynamic> deleteAllData();Future<dynamic> update<T>(List<T> newList,{String? where, bool transaction = false});Future<List<T>> select<T>({String? restrain, bool transaction = false});}class DaoFactory {DaoFactory._();static IBaseDao<T> getDao<T>(T t) =>AppComponent.appConfig.getDao<T>(t);}abstract class ISpUtils {Future<bool> saveData<T>(String key, T data);Future<T> loadData<T>(String key, T def);Future<bool> remove(String key);}class SpUtils {static ISpUtils get _spInstance =>_sp ??= AppComponent.appConfig.spUtils;static ISpUtils? _sp;static Future<bool> saveData<T>(String key, T data) =>_spInstance.saveData<T>(key, data);static Future<T> loadData<T>(String key, T def) =>_spInstance.loadData<T>(key, def);static Future<bool> remove(String key) => _spInstance.remove(key);SpUtils._();}abstract class ICheckResponse<T> {bool get isSuccess;bool get isTokenExpired;bool get isRefreshTokenExpired;final int statusCode;final String statusMessage;final T? data;final dynamic error;ICheckResponse({required this.statusCode,required this.statusMessage,this.data,this.error});@override String toString() {return 'ICheckResponse<$T>{statusCode: $statusCode, statusMessage: $statusMessage, data: $data, error: $error}';}}abstract class JsonBean<T> {T? fromJson(Map<String, dynamic>? json);Map<String, dynamic> toJson();T? get mock => null;}class HttpConfig {final String baseUrl;final int connectTimeout;final int sendTimeout;final int receiveTimeout;final String serverCA;final String clientCA;final String clientKey;@deprecated final List<String> urlPath;final Map<String, dynamic>? extra;final List<dynamic>? interceptors;final CheckResponseConfig responseConfig;HttpConfig({required this.baseUrl,required this.responseConfig,this.connectTimeout = 5000,this.sendTimeout = 5000,this.receiveTimeout = 5000,this.serverCA = "",this.clientCA = "",this.clientKey = "",this.urlPath = const ['*'],required this.interceptors,this.extra});}class CheckResponseConfig {final String codeKey;final String messageKey;final String dataKey;final List<int> successStatusCode;final List<int> tokenExpiredStatusCode;final List<int> refreshTokenExpiredStatusCode;final Map<dynamic, int> errorCodeConverter;final Map<int, String> errorCode2Explain;CheckResponseConfig({required this.codeKey,required this.messageKey,required this.dataKey,required this.successStatusCode,required this.tokenExpiredStatusCode,this.refreshTokenExpiredStatusCode = const [],this.errorCodeConverter = const {},this.errorCode2Explain = const {}});}abstract class IRequestModel {final List<HttpConfig> httpConfigs;const IRequestModel({required this.httpConfigs});Future<ICheckResponse<T>> request<T>(String requestMethod, String url,{T? jsonModel,String? contentType,Map<String, dynamic>? headerMap,Map<String, dynamic>? queryParameters,Map<String, dynamic>? body,dynamic data,dynamic options,bool allowDataNull = true,bool isICheckResponse = true,int? connectTimeout,bool throwErrorStack = false,dynamic cancelToken,DoOnValveCallBack<T>? onData,DoOnValveCallBack<ICheckResponse>? onError,DoOnValveCallBack<bool>? onDone,Function(int count, int total)? onSendProgress,Function(int count, int total)? onReceiveProgress});}const GET = 'get',POST = "post",PUT = "put",DELETE = "delete",PATCH = "patch";class RequestModel {RequestModel._();static IRequestModel get _requestModelInstance =>_requestModel ??= AppComponent.appConfig.requestModel;static IRequestModel? _requestModel;static Future<ICheckResponse<T>> request<T>(String requestMethod, String url,{T? jsonModel,String? contentType,Map<String, dynamic>? headerMap,Map<String, dynamic>? queryParameters,Map<String, dynamic>? body,dynamic data,dynamic options,bool allowDataNull = true,bool isICheckResponse = true,int? connectTimeout,bool throwErrorStack = false,dynamic cancelToken,DoOnValveCallBack<T>? onData,DoOnValveCallBack<ICheckResponse>? onError,DoOnValveCallBack<bool>? onDone,Function(int count, int total)? onSendProgress,Function(int count, int total)? onReceiveProgress}) {return _requestModelInstance.request<T>(requestMethod, url,jsonModel: jsonModel,contentType: contentType,headerMap: headerMap,queryParameters: queryParameters,body: body,data: data,options: options,allowDataNull: allowDataNull,isICheckResponse: isICheckResponse,throwErrorStack: throwErrorStack,connectTimeout: connectTimeout,cancelToken: cancelToken,onData: onData,onError: onError,onDone: onDone,onSendProgress: onSendProgress,onReceiveProgress: onReceiveProgress);}}abstract class ILogPrint {void logV([Object? object]);void logD([Object? object]);void logI([Object? object]);void logW([Object? object]);void logE([Object? object]);void logJson([Object? object]);void logXml([Object? object]);}ILogPrint get _logPrintInstance =>_logPrint ??= AppComponent.appConfig.logPrint;ILogPrint? _logPrint;void logV([Object? object]) => _logPrintInstance.logV(object);void logD([Object? object]) => _logPrintInstance.logD(object);void logI([Object? object]) => _logPrintInstance.logI(object);void logW([Object? object]) => _logPrintInstance.logW(object);void logE([Object? object]) => _logPrintInstance.logE(object);void logJson([Object? object]) => _logPrintInstance.logJson(object);void logXml([Object? object]) => _logPrintInstance.logXml(object);typedef ValueGetter<T> = T Function();void logX(ValueGetter<Object?>? f) => _logPrintInstance.logD(f?.call());typedef RefreshWidgetBuilder<T> = Widget Function(BuildContext context,IPagingListModel pageModel, T refreshController, Widget child,{Map<String, dynamic>? extra});abstract class IPagingListModel<T> {int get pagingSize;List<T> get dataList;Future<List<T>> load(final int args1, final int args2);Future<List<T>> onRefresh();Future<List<T>> onLoadMore();RefreshWidgetBuilder get refreshWidgetBuilder;}abstract class PagingListModel<T> implements IPagingListModel<T> {IPagingListModel<T>? _pagingListModelProxy;IPagingListModel<T> get pagingProxy => _pagingListModelProxy ??=AppComponent.appConfig.pagingListModelBuilder<T>(this);@override Future<List<T>> onLoadMore() => pagingProxy.onLoadMore();@override Future<List<T>> onRefresh() => pagingProxy.onRefresh();@override RefreshWidgetBuilder get refreshWidgetBuilder =>pagingProxy.refreshWidgetBuilder;@override int get pagingSize => pagingProxy.pagingSize;@override List<T> get dataList => pagingProxy.dataList;}class RefreshPagingWidget extends StatefulWidget {final IPagingListModel pageModel;final Widget child;dynamic refreshController;final Map<String, dynamic>? extra;RefreshPagingWidget({Key? key,required this.pageModel,required this.child,this.refreshController,this.extra}): super(key: key);@override _RefreshPagingWidgetState createState() {return _RefreshPagingWidgetState();}}class _RefreshPagingWidgetState extends State<RefreshPagingWidget> {@override Widget build(BuildContext context) {return widget.pageModel.refreshWidgetBuilder(context, widget.pageModel, widget.refreshController, widget.child,extra: widget.extra);}}abstract class ITipsInterceptor {void showToast(String? msg);void showNotification(String? msg);void showLoading({String? msg});void dismissLoading({int milliseconds = 0});void showWidget(Widget widget);void showCommonDialog({String? title,String? content,String? leftText,required String rightText,VoidCallback? leftOnTap,VoidCallback? rightOnTap,Map<String, dynamic>? extra,});}ITipsInterceptor get _tipsInstance =>_tips ??= AppComponent.appConfig.tips;ITipsInterceptor? _tips;void showToast(String? msg) => _tipsInstance.showToast(msg);void showNotification(String? msg) => _tipsInstance.showNotification(msg);void showLoading({String? msg}) => _tipsInstance.showLoading(msg: msg);void dismissLoading({int milliseconds = 0}) =>_tipsInstance.dismissLoading(milliseconds: milliseconds);void showWidget(Widget widget) => _tipsInstance.showWidget(widget);void showCommonDialog({String? title,String? content,String? leftText,required String rightText,VoidCallback? leftOnTap,VoidCallback? rightOnTap,Map<String, dynamic>? extra,}) =>_tipsInstance.showCommonDialog(rightText: rightText,leftText: leftText,rightOnTap: rightOnTap,leftOnTap: leftOnTap,title: title,content: content,extra: extra);typedef DoOnValveCallBack<T> = void Function(T value);typedef DoOnVoidCallBack = void Function();abstract class IViewModel {Map<String, Future<ICheckResponse> Function(RequestAction action)>get requestFutureBuilderMap;Future<ICheckResponse<T>> dispatchAction<T>(RequestAction action, {final bool? loadingShow,DoOnVoidCallBack? onLoading,DoOnValveCallBack<T>? onData,DoOnValveCallBack<ICheckResponse>? onError,DoOnValveCallBack<bool>? onDone,});Future<ICheckResponse<T>> dispatchActionByName<T>(String actionName, {final bool? loadingShow,DoOnVoidCallBack? onLoading,DoOnValveCallBack<T>? onData,DoOnValveCallBack<ICheckResponse>? onError,DoOnValveCallBack<bool>? onDone,});List<IViewModel Function()>? mixinChildViewModel();T of<T extends IViewModel>();}class RequestAction<T> {final String name;final int? what, what1, what2;final T? data;final dynamic arg1, arg2;final bool showLoading;final Map<String, dynamic>? argMap;const RequestAction(this.name,{this.what,this.what1,this.what2,this.data,this.arg1,this.arg2,this.showLoading = true,this.argMap});@override String toString() {return 'RequestAction{name: $name, what: $what, what1: $what1, what2: $what2, data: $data, arg1: $arg1, arg2: $arg2, showLoading: $showLoading, argMap: $argMap}';}}abstract class AbstractViewModel implements IViewModel {@override List<IViewModel Function()>? mixinChildViewModel() => null;@override T of<T extends IViewModel>() => proxy.of<T>();IViewModel? _viewModelProxy;IViewModel get proxy =>_viewModelProxy ??= AppComponent.appConfig.viewModelBuilder(this);@override Future<ICheckResponse<T>> dispatchAction<T>(RequestAction action,{bool? loadingShow,DoOnVoidCallBack? onLoading,DoOnValveCallBack<T>? onData,DoOnValveCallBack<ICheckResponse>? onError,DoOnValveCallBack<bool>? onDone}) =>proxy.dispatchAction<T>(action,loadingShow: loadingShow,onLoading: onLoading,onData: onData,onError: onError,onDone: onDone);@override Future<ICheckResponse<T>> dispatchActionByName<T>(String actionName,{bool? loadingShow,DoOnVoidCallBack? onLoading,DoOnValveCallBack<T>? onData,DoOnValveCallBack<ICheckResponse>? onError,DoOnValveCallBack<bool>? onDone}) =>proxy.dispatchActionByName<T>(actionName,loadingShow: loadingShow,onLoading: onLoading,onData: onData,onError: onError,onDone: onDone);}getT<T>() => T;class BuildConfig {static const bool isProfile = const bool.fromEnvironment("dart.vm.profile");static const bool isRelease = const bool.fromEnvironment("dart.vm.product");static bool get isDebug {bool inDebug = false;assert(inDebug = true);return inDebug;}static bool get isBeta => AppComponent.appConfig.isBeta;static String get compileMode {if (isDebug) {return "debug";} else if (isProfile) {return "profile";} else if (isRelease) {return "release";} else {return "Unknown type";}}}_getT<T>() => T;class CommonAssert {static void genericTMustExplicit<T>({String msg = "未明确泛型T"}) {genericSingleTMustExplicit<T>();genericListTMustExplicit<T>();}static void genericSingleTMustExplicit<T>({String msg = "未明确泛型Single T"}) {assert(T != _getT<void>() && T != _getT<Object>() && T != _getT<dynamic>(),msg);}static void genericListTMustExplicit<T>({String msg = "未明确List泛型 T"}) {assert(T != _getT<List<dynamic>>() && T != _getT<List<Object>>(), msg);}}Map<String, Function> _map = HashMap<String, Function>();Map<String, MapEntry<Type, Type>> _typeMap =HashMap<String, MapEntry<Type, Type>>();typedef RegisterFunction<Result, Args> = Result Function(Args args);class FunctionRegistry {static const String _beginName = "@";static void register<Result, Args>(String name, RegisterFunction<Result, Args> function) {debugPrint('注册Function name=$name Result=$Result, Args=$Args');assert(name.startsWith("$_beginName"), "Function name 需要以 $_beginName 开头 ");assert(!_map.containsKey(name), "Function name 已存在");_map[name] = function;assert(() {_typeMap[name] = MapEntry(Result, Args);return true;}());}static Result call<Result, Args>(String name, {Args? data}) {debugPrint('call Function name=$name Result=$Result, Args=$Args');assert(name.startsWith("$_beginName"), "Function name 需要以 $_beginName 开头 ");if (!_map.containsKey(name)) {throw FormatException('Function:$name 未注册');}assert(_check<Result, Args>(name, data: data));return _map[name]!.call(data);}static Result? callMaybe<Result, Args>(String name, {Args? data}) {if (!_map.containsKey(name)) {debugPrint('callMaybe Function name=$name Result=$Result, Args=$Args');assert(name.startsWith("$_beginName"), "Function name 需要以 $_beginName 开头 ");return null;} else {return call(name, data: data);}}static bool _check<Result, Args>(String name, {Args? data}) {var result = _typeMap[name]!.key;var args = _typeMap[name]!.value;assert(result is Result ||result == dynamic ||Result == result ||result.toString() == Result.toString(),"\ncall$name错误 Result 类型不匹配!期望$result 入参${Result}");assert((Args == dynamic && args == dynamic) ||args == Args ||args == Object ||args == getT<Object?>() ||args.toString() == Args.toString(),"\ncall$name错误 Args 类型不匹配!期望$args 入参${Args}");return true;}}typedef Json2BeanFunction<T> = T Function(dynamic json);Map<Type, Json2BeanFunction> _beanTypeMap = HashMap<Type, Json2BeanFunction>();class Json2BeanRegistry {static void register<T>(Json2BeanFunction<T> function) {CommonAssert.genericTMustExplicit<T>(msg: "未明确注册类型 T=$T");assert(function.toString().split(' ').last == (T.toString()));_beanTypeMap[T] = function;_beanTypeMap[getT<List<T>>()] =(json) => (json as List).map<T>(function).toList();}static T formJson<T>(dynamic json, {T? jsonModel}) {CommonAssert.genericTMustExplicit<T>(msg: "未明确注册类型 T=$T");if (jsonModel != null) {if (jsonModel is List<JsonBean>) {List<JsonBean> dataList = jsonModel;dataList.clear();logW("检查formJson<T>的数组类型${dataList.runtimeType} ${dataList.length}");json.map((itemJson) {var item = jsonModel.first.fromJson(itemJson);if (item != null) {dataList.add(item);}return itemJson;}).toList();return dataList as T;} else if (jsonModel is JsonBean) {return jsonModel.fromJson(json);}}if (json is List) {json.removeWhere((element) => element == null);} else if (json is Map<String, dynamic>) {json.removeWhere((key, value) => value == null);}return _beanTypeMap[T]!.call(json);}}